#include "SD.h"
#include <libraries/asl.h>
#include <proto/asl.h>

/* This file is for accessing the ASL file requester if available. */

struct Library *AslBase;
static struct FileRequester *FileRequester;

static struct TagItem Tags[6]={	{ ASL_Hail, &DefaultTitle },
										{ ASL_Dir, &DefaultDir },
										{ ASL_Pattern, (char *)(&DefaultDir)+5 },
										{ ASL_FuncFlags, FILF_PATGAD | FILF_NEWIDCMP },
										{ ASL_Window, NULL },
										{ TAG_DONE, NULL }	};

unsigned char *ASLGetFile(void) {

	unsigned char *AS = NULL;
	unsigned int n;
	struct TagItem *t = &Tags[4];

	Tags[4].ti_Data = (ULONG)Window;
	if (!FileRequester) {
		if (!(FileRequester = AllocFileRequest())) return(NULL);
		t = Tags;
	}
	if (AslRequest(FileRequester, t) &&
		(n = strlen(FileRequester->rf_Dir)+strlen(FileRequester->rf_File)) &&
		(AS = CreateArgstring(FileRequester->rf_Dir, n+4)))
		AddPart(AS, FileRequester->rf_File, n+4);
	return(AS);
}

void ASLFreeFileReq(void) {
	if (FileRequester) FreeFileRequest(FileRequester);
}
