#include "SDInc.c"

/*
 * This structure, directly derived from Dirk's code, allows for easy
 * parameter passing of the blitter operations.
 */

struct ExtendedBlitNode	{
	struct bltnode	EBN_bltnode;
	UWORD				EBN_Pad;
	APTR				EBN_P0;
	APTR				EBN_P1;
	APTR				EBN_P2;
	APTR				EBN_P3;
	ULONG				EBN_Mask;
	struct Task		*EBN_Task;
};

struct InterruptServerData {
	ULONG				ISD_Mask;
	struct Task		*ISD_Task;
};

struct DiskBlockServerData {
	struct InterruptServerData DBSD_ISD;
	struct Interrupt *DBSD_SoftInt;
};

struct SyncIntData {
	UBYTE SD_EnableSecCounter;
	UBYTE SD_GetSync;
	WORD	SD_SecCounter;
	struct MsgPort *SD_SyncIntPort;
	struct timerequest *SD_SyncInt_tr;
	struct Interrupt *SD_SyncInt;
};

struct SoftIntData {
	struct InterruptServerData SID_ISD;
	struct MsgPort *SID_SoftIntPort;
	struct timerequest *SID_SoftInt_tr;
	unsigned char	*SID_VerifyBuffer;
	USHORT	SID_VerifyLength;
	USHORT	SID_CIABPRB;
	ULONG		SID_ADKCON;
	struct DiskBlockServerData *SID_DiskBlockServerData;
};


#define	SE_Sync		(4)
#define	SE_Header	(SE_Sync+4)
#define	SE_Label		(SE_Header+8)
#define	SE_SumL		(SE_Label+TD_LABELSIZE*2)
#define	SE_SumD		(SE_SumL+8)
#define	SE_Data		(SE_SumD+8)

#define GAPSIZE (1660)
#define BLOCKSIZE (1088)
#define SPT (11)
#define TRACKSIZE ((ULONG)(SPT*512))
#define RAMBUFFERBLOCK (TRACKSIZE*2)
#define READBUFFERSIZE (SPT*BLOCKSIZE+2*GAPSIZE+2+8)
#define VERIFYBUFFERSIZE (SPT*BLOCKSIZE+GAPSIZE+2+8)
#define WRITELENGTH (SPT*BLOCKSIZE+2)
#define READLENGTH (SPT*BLOCKSIZE+2)
#define VERIFYLENGTH (SPT*BLOCKSIZE+2)
#define GAPADD (192)
#define MINGAP (532)

/*
* This macros read & write the bit masks such as ActualDest
*/

#define MASK(x) (1UL<<(x))
#define INDEST(x) ((MASK(x)) & Dest)
#define INACTUALDEST(x) ((MASK(x)) & ActualDest)
#define INMASK(x,y) (MASK(x) & (y))

enum Gadgets { DF0S, DF1S, DF2S, DF3S, DF0D, DF1D, DF2D, DF3D, BUFFER, HDBUF, VDBUF,
					VERIFY, DATE, INCNAME, FFS, TALK, AUTO, STOP, GO, READ, CHECK, FORMAT,
					AREXX, KILLSYS, LABEL, VDNUMBER, RETRY, VDNAME, SCYL, ECYL };

enum Buffers { NO_BUFFER, RAM_BUFFER, HD_BUFFER, VDISK_BUFFER };

#include "AsmProtos.h"
#include "Protos.h"
