		INCLUDE "exec/types.i"
		INCLUDE "devices/trackdisk.i"
		INCLUDE "hardware/blit.i"

SYNC		equ	$4489			Uniq pattern to recognise the beginning of data
SYNCSYNC	equ	$44894489		idem
GAPSIZE		equ	1660			Size of first written non-data part of a track
SPT		equ	11			Sectors per track
DSKWRITE	equ	%0100000000000000
DSKSEL		equ	CIAF_DSKSEL0+CIAF_DSKSEL1+CIAF_DSKSEL2+CIAF_DSKSEL3


	      STRUCTURE EBN,bn_SIZEOF		Extended blit node, data area available for blitter fuctions
		WORD	EBN_Pad			Long alignment
		APTR	EBN_P0			Some pointers
		APTR	EBN_P1
		APTR	EBN_P2
		APTR	EBN_P3
		ULONG	EBN_Mask		The signal to say we finished
		APTR	EBN_Task		Where to signal
		LABEL	EBN_SIZE

	      STRUCTURE HE,0			Sector Header structure
		BYTE	HE_Format		Contens: DISKFORMAT
		BYTE	HE_TrkNo		Tracknumber the formatter thought the head was on during format
		BYTE	HE_SecNo		Sectornumber from 0 to 10
		BYTE	HE_ToGap		Number of sectors until gap
		LABEL	HE_SIZE			Warning: Maybe subtracted from the stackpointer

	      STRUCTURE SE,0			MFM encoded sector
		ULONG	SE_Start		Contens: $AAAAAAAA
		ULONG	SE_Sync			Contens: SYNCSYNC
		STRUCT	SE_Header,HE_SIZE*2	HE_ structure
		STRUCT	SE_Label,TD_LABELSIZE*2
		STRUCT	SE_SumL,4*2		Checksum over SE_Header and SE_Label
		STRUCT	SE_SumD,4*2		Checksum over SE_Data
		STRUCT	SE_Data,TD_SECTOR*2
		LABEL	SE_SIZE

SSIZE		equ	SE_SIZE-SE_Label
LSIZE		equ	SE_SumL-SE_Label
DSIZE		equ	SE_SIZE-SE_SumD

	      STRUCTURE ISD,0			The interrupt server data
		ULONG	ISD_Mask		The message with which to signal
		APTR	ISD_Task		And where to put it
		LABEL	ISD_SIZE

	      STRUCTURE DBSD,ISD_SIZE		The diskblock server data
		APTR	DBSD_SoftInt		If non-NULL, the SoftInt to Cause()
		LABEL	DBSD_SIZE

	      STRUCTURE SID,ISD_SIZE		The SoftInt server data
		APTR	SID_SoftIntPort		The port which causes the SoftInt
		APTR	SID_SoftInt_tr		The timerequest that's replied to that port
		APTR	SID_VerifyBuffer	A verify buffer
		USHORT	SID_VerifyLength	How much to verify
		USHORT	SID_CIABPRB		Register settings to verify
		ULONG	SID_ADKCON
		APTR	SID_DiskBlockServerData	The DSKBLK server data
		LABEL	SID_SIZE

	      STRUCTURE	SD,0
		UBYTE	SD_EnableSecCounter
		UBYTE	SD_GetSync
		WORD	SD_SecCounter
		APTR	SD_SyncIntPort
		APTR	SD_SyncInt_tr
		APTR	SD_SyncInt
		LABEL	SD_SIZE
