#include "SD.h"
#include <graphics/clip.h>
#include <libraries/amigaguide.h>
#include <clib/amigaguide_protos.h>
#include <pragmas/amigaguide_pragmas.h>

#define DISKNAMELEN (30)
#define DEVICENAMELEN (64)

#define GADGETHEIGHT 16
#define INTERGADGET 4
#define GADGETSKIP	(GADGETHEIGHT+INTERGADGET)
#define FIRSTGROUPOFFSET	6
#define PROGRESSBAROFFSET (FIRSTGROUPOFFSET+GADGETSKIP)
#define PROGRESSBARHEIGHT	13
#define SECONDGROUPOFFSET	(PROGRESSBAROFFSET+PROGRESSBARHEIGHT+INTERGADGET)
#define THIRDGROUPOFFSET (SECONDGROUPOFFSET+GADGETSKIP*2+4)
#define FOURTHGROUPOFFSET (THIRDGROUPOFFSET+16)

#define WINDOWWIDTH (560)
#define WINDOWHEIGHT (FOURTHGROUPOFFSET+GADGETSKIP*2+GADGETHEIGHT+FIRSTGROUPOFFSET)

#define LISTHEIGHT (((WINDOWHEIGHT-FIRSTGROUPOFFSET*2-GADGETHEIGHT-3)/8)*8)
#define LISTOFFSET (WINDOWHEIGHT-FIRSTGROUPOFFSET-LISTHEIGHT-2)
#define DISKNAMES  (LISTHEIGHT/8)

static UWORD chip GadgetImageData[] =	{
														0x0000, 0x0000, 0x0000, 0x0001,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x0000, 0x0000, 0x0000, 0x0003,
														0x7FFF, 0xFFFF, 0xFFFF, 0xFFFF,

														0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0xC000, 0x0000, 0x0000, 0x0000,
														0x8000, 0x0000, 0x0000, 0x0000,
													};

static struct Image	Image = { 0,0, 64,16, 2, GadgetImageData, 3, 0 };

void	HyperSegList(void);
static struct Library *AmigaGuideBase;
struct SignalSemaphore HyperSemaphore;

static unsigned char df0[] = "df0:" ;				  /* use only one copy of this name */
static unsigned char df1[] = "df1:" ;				  /* ditto */
static unsigned char df2[] = "df2:" ;				  /* ditto */
static unsigned char df3[] = "df3:" ;				  /* ditto */
unsigned char *df[]={df0, df1, df2, df3};	  /* for easy access to drive names */
unsigned char s[128];	/* Temp string */

char *PubScreen;

static unsigned char Title[] = "SuperDuper 2.03  1991,1992,1993 Sebastiano Vigna";
static unsigned char KillSYS[] = "KillSys";
static unsigned char Restore[] = "Restore";
static unsigned char NoCloseWB[] = "Can't close Workbench.";
static unsigned char NoOpenWB[] = "Can't open Workbench.";
static unsigned char CloseHyperSystem[] = "Please close the help system.";
static unsigned char HelpFileName[] = "SuperDuper.guide";
static unsigned char HelpTaskName[] = "SD_Help";

struct Window *Window;				/* the window */
static char TopBorder;				/* Minimum font adaptivity */

static APTR OldWindowPtr, CopyTaskOldWindowPtr;			/* Old WindowPtr in the Process structure */

struct SignalSemaphore Semaphore;

/*
 *	  Always use topaz 80, and let's define an intuition buffer for our
 *	  general string writing stuff.
 */

static struct TextAttr Topaz8 = {(STRPTR)"topaz.font", TOPAZ_EIGHTY, 0, 0 };
static struct IntuiText IntuiText = {1, 0, JAM2, 0, 0, &Topaz8} ;

/*
 * The copy progress bar 3D border.
 */

static SHORT XY1[10]={ 62,0,0,0,0,GADGETHEIGHT-1,1,GADGETHEIGHT-2,1,1 };
static SHORT XY2[10]={ 1,GADGETHEIGHT-1,63,GADGETHEIGHT-1,63,0,62,1,62,GADGETHEIGHT-2 };

static SHORT BXY1[10]={ 1,PROGRESSBARHEIGHT-1,323,PROGRESSBARHEIGHT-1,323,0,322,1,322,PROGRESSBARHEIGHT-2 };
static SHORT BXY2[10]={ 322,0,0,0,0,PROGRESSBARHEIGHT-1,1,PROGRESSBARHEIGHT-2,1,1 };

static SHORT LXY1[10]={ 1,LISTHEIGHT+1,125,LISTHEIGHT+1,125,0,124,1,124,LISTHEIGHT };
static SHORT LXY2[10]={ 124,0,0,0,0,LISTHEIGHT+1,1,LISTHEIGHT,1,1 };

static SHORT TXY1[10]={ 1,15,125,15,125,0,124,1,124,14 };
static SHORT TXY2[10]={ 124,0,0,0,0,15,1,14,1,1 };

static SHORT SXY1[10]={ 1,13,131,13,131,0,130,1,130,12 };
static SHORT SXY2[10]={ 130,0,0,0,0,13,1,12,1,1 };
static SHORT SXY3[10]={ 3,12,129,12,129,1,128,2,128,11 };
static SHORT SXY4[10]={ 128,1,2,1,2,12,3,11,3,2 };

static SHORT RXY1[10]={ 1,13,35,13,35,0,34,1,34,12 };
static SHORT RXY2[10]={ 34,0,0,0,0,13,1,12,1,1 };
static SHORT RXY3[10]={ 3,12,33,12,33,1,32,2,32,11 };
static SHORT RXY4[10]={ 32,1,2,1,2,12,3,11,3,2 };

static struct Border Border[] = {
	{	0,0,2,0,JAM1,5,BXY1,&Border[1]	},
	{	0,0,1,0,JAM1,5,BXY2,NULL	},
	{	0,0,2,0,JAM1,5,LXY1,&Border[3]	},
	{	0,0,1,0,JAM1,5,LXY2,NULL	},
	{	0,0,2,0,JAM1,5,TXY1,&Border[5]	},
	{	0,0,1,0,JAM1,5,TXY2,NULL	},
	{	0,0,2,0,JAM1,5,XY2,&Border[7] },
	{	0,0,1,0,JAM1,5,XY1,NULL	},
	{	-6,-3,2,0,JAM1,5,SXY2,&Border[9] },
	{	-6,-3,1,0,JAM1,5,SXY1,&Border[10] },
	{	-6,-3,2,0,JAM1,5,SXY3,&Border[11] },
	{	-6,-3,1,0,JAM1,5,SXY4,NULL },
	{	-6,-3,2,0,JAM1,5,RXY2,&Border[13] },
	{	-6,-3,1,0,JAM1,5,RXY1,&Border[14] },
	{	-6,-3,2,0,JAM1,5,RXY3,&Border[15] },
	{	-6,-3,1,0,JAM1,5,RXY4,NULL },
};

/*
 * ITexts for gadgets.
 */

static unsigned char US[] = "_";

static struct IntuiText USIText[9] = {
	{	1,0,JAM1, 17+8*2,5, &Topaz8, US	},
	{	1,0,JAM1, 8,5, &Topaz8, US	},
	{	1,0,JAM1, 12,5, &Topaz8, US	},
	{	1,0,JAM1, 12+8*3,5, &Topaz8, US	},
	{	1,0,JAM1, 16,5, &Topaz8, US	},
	{	1,0,JAM1, 4,5, &Topaz8, US	},
	{	1,0,JAM1, 16+8*3,5, &Topaz8, US	},
	{	1,0,JAM1, 24,5, &Topaz8, US	},
	{	1,0,JAM1, 4,5, &Topaz8, US	}
};

static struct IntuiText IText[24] = {
	{	1,0,JAM1, 17,4, &Topaz8, df0, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df1, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df2, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df3, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df0, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df1, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df2, &USIText[0]	},
	{	1,0,JAM1, 17,4, &Topaz8, df3, &USIText[0]	},
	{	1,0,JAM1, 8,4, &Topaz8, "Buffer", &USIText[1]	},
	{	1,0,JAM1, 12,4, &Topaz8, "HDBuf", &USIText[2]	},
	{	1,0,JAM1, 12,4, &Topaz8, "VDBuf", &USIText[3]	},
	{	1,0,JAM1, 8,4, &Topaz8, "Verify", &USIText[1]	},
	{	1,0,JAM1, 16,4, &Topaz8, "Date", &USIText[4]	},
	{	1,0,JAM1, 4,4, &Topaz8, "IncName", &USIText[5]	},
	{	1,0,JAM1, 16,4, &Topaz8, "FFS.", &USIText[6]	},
	{	1,0,JAM1, 16,4, &Topaz8, "Talk", &USIText[4]	},
	{	1,0,JAM1, 16,4, &Topaz8, "Auto", &USIText[4]	},
	{	1,0,JAM1, 16,4, &Topaz8, "Stop", &USIText[4]	},
	{	1,0,JAM1, 24,4, &Topaz8, "Go", &USIText[7] },
	{	1,0,JAM1, 16,4, &Topaz8, "Read", &USIText[4]	},
	{	1,0,JAM1, 12,4, &Topaz8, "Check", &USIText[2]	},
	{	1,0,JAM1, 8,4, &Topaz8, "Format", &USIText[1]	},
	{	1,0,JAM1, 12,4, &Topaz8, "ARexx", &USIText[3]	},
	{	1,0,JAM1, 4,4, &Topaz8, KillSYS, &USIText[8]	}
};




/*
 * The gadgets.
 */

static unsigned char DiskName[DISKNAMELEN+1] = "Empty",
							DeviceName[DEVICENAMELEN+1],
							RetryChars[3]="4",
							VDChars[3] = "0",
							SCylChars[3] = "0",
							ECylChars[3] = "79";

static struct StringInfo ECylStrInfo = {
	ECylChars, NULL, 0, 3, 0, 0, 0, 0, 0, 0, NULL, 79
};

static struct Gadget ECylGadget =	{
	NULL, 326+60, 114, 24, 8,
	GADGHCOMP | GFLG_TABCYCLE, LONGINT, STRGADGET,
	(APTR)&Border[12], NULL, NULL, NULL, (APTR)&ECylStrInfo, -1, NULL
};

static struct StringInfo SCylStrInfo = {
	SCylChars, NULL, 0, 3, 0, 0, 0, 0, 0, 0, NULL, 0
};

static struct Gadget SCylGadget =	{
	&ECylGadget, 326+60, 114, 24, 8,
	GADGHCOMP | GFLG_TABCYCLE, LONGINT, STRGADGET,
	(APTR)&Border[12], NULL, NULL, NULL, (APTR)&SCylStrInfo, -1, NULL
};

static struct StringInfo VDNameStrInfo = {
	DeviceName, NULL, 0, DEVICENAMELEN+1
};

static struct Gadget VDNameGadget =	{
	&SCylGadget, 222+68, 114, 120, 8,
	GADGHCOMP | GFLG_TABCYCLE, 0, STRGADGET,
	(APTR)&Border[8], NULL, NULL, NULL, (APTR)&VDNameStrInfo, -1, NULL
};

static struct StringInfo RetryStrInfo = {
	RetryChars, NULL, 0, 3, 0, 0, 0, 0, 0, 0, NULL, 4
};

static struct Gadget RetryGadget =	{
	&VDNameGadget, 326+60, 114, 24, 8,
	GADGHCOMP | GFLG_TABCYCLE, LONGINT, STRGADGET,
	(APTR)&Border[12], NULL, NULL, NULL, (APTR)&RetryStrInfo, -1, NULL
};

static struct StringInfo VDNumberStrInfo = {
	VDChars, NULL, 0, 3, 0, 0, 0, 0, 0, 0, NULL, 0
};

static struct Gadget VDNumberGadget =	{
	&RetryGadget, 222+68, 114, 24, 8,
	GADGHCOMP | GFLG_TABCYCLE, LONGINT, STRGADGET,
	(APTR)&Border[12], NULL, NULL, NULL, (APTR)&VDNumberStrInfo, -1, NULL
};

static struct StringInfo StrInfo = {
	DiskName, NULL, 0, DISKNAMELEN+1
};

static struct Gadget StrGadget =	{
	&VDNumberGadget, 86, 114, 120, 8,
	GADGHCOMP | GFLG_TABCYCLE, 0, STRGADGET,
	(APTR)&Border[8], NULL, NULL, NULL, (APTR)&StrInfo, -1, NULL
};

static struct Gadget Gadget[24] = {
	{	&Gadget[1], 80,20, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[0], NULL, NULL, '0', NULL
	},
	{	&Gadget[2], 148,20, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[1], NULL, NULL, '1', NULL
	},
	{	&Gadget[3], 216,20, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[2], NULL, NULL, '2', NULL
	},
	{	&Gadget[4], 284,20, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[3], NULL, NULL, '3', NULL
	},
	{	&Gadget[5], 80,50, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[4], NULL, NULL, '4', NULL
	},
	{	&Gadget[6], 148,50, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[5], NULL, NULL, '5', NULL
	},
	{	&Gadget[7], 216,50, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[6], NULL, NULL, '6', NULL
	},
	{	&Gadget[8], 284,50, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[7], NULL, NULL, '7', NULL
	},
	{	&Gadget[9], 12,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[8], NULL, NULL, 'B', NULL
	},
	{	&Gadget[10], 80,112, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[9], NULL, NULL, 'H', NULL
	},
	{	&Gadget[11], 148,112, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[10], NULL, NULL, 'U', NULL
	},
	{	&Gadget[12], 12,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE | SELECTED, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[11], NULL, NULL, 'V', NULL
	},
	{	&Gadget[13], 80,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE | SELECTED, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[12], NULL, NULL, 'D', NULL
	},
	{	&Gadget[14], 148,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[13], NULL, NULL, 'I', NULL
	},
	{	&Gadget[15], 216,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[14], NULL, NULL, '.', NULL
	},
	{	&Gadget[16], 284,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[15], NULL, NULL, 'T', NULL
	},
	{	&Gadget[17], 352,82, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[16], NULL, NULL, 'A', NULL
	},
	{	&Gadget[18], 12,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[17], NULL, NULL, 'S', NULL
	},
	{	&Gadget[19], 80,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[18], NULL, NULL, 'G', NULL
	},
	{	&Gadget[20], 148,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[19], NULL, NULL, 'R', NULL
	},
	{	&Gadget[21], 216,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[20], NULL, NULL, 'C', NULL
	},
	{	&Gadget[22], 284,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, GADGIMMEDIATE | TOGGLESELECT, BOOLGADGET,
		(APTR)&Image, NULL, &IText[21], NULL, NULL, 'F', NULL
	},
	{	&Gadget[23], 352,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE | GADGDISABLED, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[22], NULL, NULL, 'X', NULL
	},
	{	&StrGadget, 352,97, 64,GADGETHEIGHT,
		GADGHCOMP | GADGIMAGE, RELVERIFY, BOOLGADGET,
		(APTR)&Image, NULL, &IText[23], NULL, NULL, 'K', NULL
	}
};


/* This is for the Zoom gadget under 2.0 */

static WORD ZoomPos[4] = { 32, 12, 128, 64 };

static struct TagItem ENWTag[4] = { { WA_Zoom, (void *)ZoomPos },
												{ WA_PubScreen, NULL },
												{ WA_PubScreenFallBack, TRUE },
												{ TAG_DONE, NULL }	};

static struct ExtNewWindow NewWindow = {
	32,12, WINDOWWIDTH,WINDOWHEIGHT, 0,1,
	GADGETDOWN | GADGETUP | CLOSEWINDOW | RAWKEY | REFRESHWINDOW,
	WINDOWDRAG | WINDOWDEPTH | WINDOWCLOSE | ACTIVATE | SMART_REFRESH | WFLG_NW_EXTENDED | RMBTRAP,
	&Gadget[0], NULL, Title, NULL, NULL, WINDOWWIDTH, WINDOWHEIGHT, WINDOWWIDTH, WINDOWHEIGHT, WBENCHSCREEN, ENWTag
};

static struct NewScreen NewScreen = {
	0,0, WINDOWWIDTH,WINDOWHEIGHT+11, 1, 0, 1, HIRES, CUSTOMSCREEN, &Topaz8, Title
};

/*
 * This structures are for AutoRequest();
 */

static struct IntuiText Req = {
	AUTOFRONTPEN, AUTOBACKPEN, AUTODRAWMODE,
	20,20,
	NULL
};

static struct IntuiText OK = {
  AUTOFRONTPEN, AUTOBACKPEN, AUTODRAWMODE,
  AUTOLEFTEDGE, AUTOTOPEDGE,
  NULL,
  "OK",
  AUTONEXTTEXT
};

static struct Screen *Screen;

/* Very simple use of AmigaGuide. Could be done better, but it's not yet time. */

void __saveds HyperHelpTask(void) {

	struct NewAmigaGuide *NewAmigaGuide;
	AMIGAGUIDECONTEXT *h;
	BPTR CDLock;

	if (AttemptSemaphore(&HyperSemaphore)) {
		SetTaskPri(FindTask(NULL),0);
		if (AmigaGuideBase = OpenLibrary("amigaguide.library",0)) {
			if (NewAmigaGuide = AllocMem(sizeof(struct NewAmigaGuide), MEMF_PUBLIC | MEMF_CLEAR)) {
				NewAmigaGuide->nag_Lock = CDLock = DupLock(((struct Process *)Me)->pr_CurrentDir);
				NewAmigaGuide->nag_Name = HelpFileName;
				NewAmigaGuide->nag_BaseName = ARexxPortName;
				NewAmigaGuide->nag_Screen = Screen;
				if (h = OpenAmigaGuide(NewAmigaGuide, NULL)) CloseAmigaGuide(h);
				FreeMem(NewAmigaGuide, sizeof(struct NewAmigaGuide));
				UnLock(CDLock);
			}
			CloseLibrary(AmigaGuideBase);
		}
		ReleaseSemaphore(&HyperSemaphore);
	}
}

void HyperHelp(void) {

	if (AttemptSemaphore(&HyperSemaphore)) {
		ReleaseSemaphore(&HyperSemaphore);
		CreateProc(HelpTaskName, Me->tc_Node.ln_Pri+1, MKBADDR(HyperSegList), 4000);
	}
}

void CloseHyperHelp(void) {

	while(!AttemptSemaphore(&HyperSemaphore)) Acknowledge(CloseHyperSystem);
	ReleaseSemaphore(&HyperSemaphore);
}


/*
 * Here we invert the border colors if we are under 1.3
 */


void SetUpImages(void) {
	ULONG *p, *q, t;
	int i;

	if (!NewOS) {
		q = (p = (ULONG *)GadgetImageData)+((64*GADGETHEIGHT)/8)/sizeof(ULONG);

		for(i=0; i<((64*GADGETHEIGHT)/8)/sizeof(ULONG); i++) {
			t = *p;
			*(p++) = *q;
			*(q++) = t;
		}
		Req.ITextFont = OK.ITextFont = &Topaz8;
	}
}

static unsigned char FlatImage;

static void EORMixImage(void) {

	ULONG *p, *q;
	unsigned int i;

	q = (p = (ULONG *)GadgetImageData)+((64*GADGETHEIGHT)/8)/sizeof(ULONG);
	for(i=0; i<((64*GADGETHEIGHT)/8)/sizeof(ULONG); i++) *(p++) ^= *(q++);
	FlatImage = !FlatImage;
}


static void BorderColors(void) {

	unsigned short i;

	for(i=0; i<sizeof(Border)/sizeof(struct Border); i++) Border[i].FrontPen = (NewOS ? 2-i%2 : 1+i%2);
	if (FlatImage) EORMixImage();
}

/* Suppose we have just two colors... */

static void BorderColorsFlat(void) {

	unsigned short i;

	for(i=0; i<sizeof(Border)/sizeof(struct Border); i++) Border[i].FrontPen = 1;
	if (!FlatImage) EORMixImage();
}


/*
 * This is for saying something that's only a notification. Only from the main task.
 */

void Acknowledge(unsigned char *Message) {

	Say(Message);
	if (Requesters) {
		Req.IText = Message;
		AutoRequest(Screen ? Window : NULL, &Req, NULL, &OK, 0, 0, 360, 72);
	}
}

void ShutScreen(void) {
	if (Screen) {
		CloseScreen(Screen);
		Screen = NULL;
	}
}

/* Close the window and restore WindowPtr */

void MyCloseWindow(void) {
	if (Window) {
		((struct Process *)Me)->pr_WindowPtr = OldWindowPtr;
		((struct Process *)Copier)->pr_WindowPtr = CopyTaskOldWindowPtr;
		CloseWindow(Window);
		Window = NULL;
	}
}

/* This function can kill or restore the system (pass 'K' or 'E'). It can be
	called only from the main task. */

unsigned char KillSys(unsigned char Op) {

	unsigned char WBClosed = 1;

	if (!Window) return(0);
	if (!Screen) {
		if (Op == 'E') return(0);
		NewScreen.Height = WINDOWHEIGHT+(NewWindow.TopEdge = 11);
		if ((NewWindow.Screen = Screen = OpenScreen(&NewScreen)) == NULL) return(0);
		else {
			ObtainSemaphore(&Semaphore);
			MyCloseWindow();
			WBClosed = CloseWorkBench();
			CloseVoice();
			FlushMem();
			Gadget[TALK].Flags &= ~SELECTED;
			NewWindow.Type = CUSTOMSCREEN;
			NewWindow.Flags = ACTIVATE | SIMPLE_REFRESH | BORDERLESS | BACKDROP | RMBTRAP;
			NewWindow.IDCMPFlags =	REFRESHWINDOW | GADGETDOWN | GADGETUP | RAWKEY;
			NewWindow.Title = NULL;
			NewWindow.LeftEdge = 0;
			IText[KILLSYS].IText = Restore;
			IText[KILLSYS].NextText->LeftEdge += 8;
			Gadget[KILLSYS].GadgetID = 'E';
		}
	}
	else {
		if (Op == 'K') return(0);
		if (!OpenWorkBench()) {
			Acknowledge(NoOpenWB);
			return(0);
		}
		ObtainSemaphore(&Semaphore);
		WBenchToFront();
		NewWindow.Type = WBENCHSCREEN;
		NewWindow.Flags = WINDOWDRAG | WINDOWDEPTH | WINDOWCLOSE | ACTIVATE | SMART_REFRESH | WFLG_NW_EXTENDED | RMBTRAP;
		NewWindow.IDCMPFlags =	REFRESHWINDOW | GADGETDOWN | GADGETUP | CLOSEWINDOW | RAWKEY;
		NewWindow.Title = Title;
		NewWindow.LeftEdge = 32;
		NewWindow.TopEdge = 12;
		MyCloseWindow();
		ShutScreen();
		IText[KILLSYS].IText = KillSYS;
		IText[KILLSYS].NextText->LeftEdge -= 8;
		Gadget[KILLSYS].GadgetID = 'K';
	}

	SetUpWindow();
	ReleaseSemaphore(&Semaphore);
	if (Window) {
		if (!WBClosed) Acknowledge(NoCloseWB);
		return(0);
	}
	else {
		ShutScreen();
		Signal(Copier, StopMask);
		Alert(AG_NoMemory);
		return(1);
	}
}


/*
 *	  This routine draws a string into the window at
 *	  a specific X, Y location.
 */

static void DrawText(unsigned char *String, int x, int y) {

	if (!Window) return;
	IntuiText.IText = (UBYTE *)String ;
	PrintIText(Window->RPort, &IntuiText, (long)x, (long)y+TopBorder) ;
}

/*
 *	  This set of routines draw the progress bar. They're fairly smart---
 *   first they update Bar, then they check for the layer we need being
 *   unlocked. If it's not the case, they set SomethingFailed go.
 *   As soon as the layer is free, the bar is redrawn basing on Bar.
 *   This allows for smooth copy operations even if someone uses menus
 *   (thus locking all layers). UpDateProgress forces the bar to be
 *   updated.
 */

static unsigned char SomethingFailed, Bar[20], Error[4][20], ListName[DISKNAMES][16], CurrentListName;

static void PrintRectAt(unsigned short n, unsigned char color) {

	SetDrMd(Window->RPort, JAM2);
	SetAPen(Window->RPort, Screen ? (color != 0 ? 1 : 0) : color);
	RectFill(Window->RPort, 21+n*4, TopBorder+PROGRESSBAROFFSET+1, 24+n*4, TopBorder+PROGRESSBAROFFSET+PROGRESSBARHEIGHT-2);
}

static void PrintErrorRectAt(unsigned char Unit, unsigned short n) {

	SetDrMd(Window->RPort, JAM2);
	SetAPen(Window->RPort, 0);
	RectFill(Window->RPort, 21+n*2, TopBorder+PROGRESSBAROFFSET+1+(PROGRESSBARHEIGHT/4)*Unit, 22+n*2, TopBorder+PROGRESSBAROFFSET+2+(PROGRESSBARHEIGHT/4)*Unit);
}

void UpdateProgress(unsigned char Always) {

	unsigned short i;
	unsigned char Unit;

	ObtainSemaphore(&Semaphore);
	if (SomethingFailed || Always) {
		for(i=0; i<80; i++) {
			PrintRectAt(i, (Bar[i/4]>>(2*(i%4))) & 3);
			for(Unit=0; Unit<4; Unit++) {
				if (Error[Unit][(i*2)/8] & 1<<((i*2)%8)) PrintErrorRectAt(Unit, i*2);
				if (Error[Unit][(i*2+1)/8] & 1<<((i*2+1)%8)) PrintErrorRectAt(Unit, i*2+1);
			}
		}
		SomethingFailed = 0;
	}
	ReleaseSemaphore(&Semaphore);
}

void DrawProgress(unsigned short n, unsigned char color) {

	ObtainSemaphore(&Semaphore);
	if (Window && (n<=79)) {
		Bar[n/4] &= ~(3<<(2*(n%4)));
		Bar[n/4] |= color<<(2*(n%4));

		if (Window->WScreen->LayerInfo.Lock.ss_NestCount == 0) {
			UpdateProgress(FALSE);
			PrintRectAt(n, color);
		}
		else SomethingFailed = 1;
	}
	ReleaseSemaphore(&Semaphore);
}

/*
 *	  This routine wipes the progress bar.
 */

void WipeProgress(unsigned short start) {

	register unsigned short i,j;

	ObtainSemaphore(&Semaphore);
	if (Window) {
		for(i=start; i<80; i++) {
			for(j=0; j<4; j++) {
				Error[j][(i*2)/8] &= ~(1<<((i*2)%8));
				Error[j][(i*2+1)/8] &= ~(1<<((i*2+1)%8));
			}
			DrawProgress(i, 0);
		}
	}
	ReleaseSemaphore(&Semaphore);
}

/* This function rebuilds the window cosmetics basing itself on the
	internal storage. Does NOT call UpdateProgress()---you have to! */

static void UpdateWindow(void) {

	register unsigned short i;

	ObtainSemaphore(&Semaphore);
	if (Window && !(Window->Flags & WFLG_ZOOMED)) {
		if (Screen) {
			SetDrMd(Window->RPort, JAM2);
			SetAPen(Window->RPort, 1);
			Move(Window->RPort, 0,0);
			Draw(Window->RPort, 0, WINDOWHEIGHT-1);
			Draw(Window->RPort, WINDOWWIDTH-1, WINDOWHEIGHT-1);
			Draw(Window->RPort, WINDOWWIDTH-1, 0);
			Move(Window->RPort, 1,0);
			Draw(Window->RPort, 1, WINDOWHEIGHT-1);
			Move(Window->RPort, WINDOWWIDTH-2,0);
			Draw(Window->RPort, WINDOWWIDTH-2, WINDOWHEIGHT-1);
		}
		DrawText("Source", 20, FIRSTGROUPOFFSET+4);
		DrawText("Dest(s)", 18, SECONDGROUPOFFSET+4);
		DrawText("Rtry:Err", 12, SECONDGROUPOFFSET+4+GADGETSKIP);
		DrawBorder(Window->RPort, &Border[0], 19, TopBorder+PROGRESSBAROFFSET);
		DrawBorder(Window->RPort, &Border[2], 354+68, TopBorder+LISTOFFSET);
		DrawBorder(Window->RPort, &Border[4], 354+68, TopBorder+FIRSTGROUPOFFSET);
		DrawText("Elapsed:", 361+68, FIRSTGROUPOFFSET+4);
		DrawText(US, 24, THIRDGROUPOFFSET+2+1);
		DrawText("Label", 24, THIRDGROUPOFFSET+2);
		DrawText("VDUnit#", 222, THIRDGROUPOFFSET+2);
		DrawText(US, 300+29+8*4, THIRDGROUPOFFSET+2+1);
		DrawText("Retry#", 300+28, THIRDGROUPOFFSET+2);
		DrawText(US, 222+8*4, FOURTHGROUPOFFSET+4+1);
		DrawText("VDName", 222, FOURTHGROUPOFFSET+4);
		DrawText("SC", 356, PROGRESSBAROFFSET+3);
		DrawText("EC", 356, SECONDGROUPOFFSET+5);
		for(i=0; i<5; i++) DrawBorder(Window->RPort, &Border[6], 80+i*68, TopBorder+SECONDGROUPOFFSET+GADGETSKIP);
		for(i=0; i<4; i++) WriteRetriesErrors(i, 160);
		WriteCopies();
		for(i=0; i<DISKNAMES; i++) DrawText(ListName[(CurrentListName+i+1)%DISKNAMES], 357+68, LISTOFFSET+1+i*8);
	}
	ReleaseSemaphore(&Semaphore);
}


void RefreshWindow(void) {
	BeginRefresh(Window);
	UpdateWindow();
	EndRefresh(Window, TRUE);
	UpdateProgress(TRUE);
}

/*
 * This sets up the window.
 */
char SetUpWindow(void) {

	struct Screen S, *PubScreenLock = NULL, *SData;
	register unsigned short i;

	if (!GUI) return(1);
	if (Screen) TopBorder = 0;
	else {
		if (NewOS) {
			if (!(SData = PubScreenLock = LockPubScreen(PubScreen))) return(0);
			ENWTag[1].ti_Data = (ULONG)PubScreenLock;
		}
		else {
			GetScreenData((void *)&S, sizeof(S), WBENCHSCREEN, NULL);
			SData = &S;
		}
		TopBorder = SData->BarHeight;
	}
	for(i=0; i<8; i++) Gadget[i].TopEdge = TopBorder+(i/4 ? SECONDGROUPOFFSET : FIRSTGROUPOFFSET);
	VDNumberGadget.TopEdge = StrGadget.TopEdge = RetryGadget.TopEdge = TopBorder+THIRDGROUPOFFSET+2;
	VDNameGadget.TopEdge = TopBorder+FOURTHGROUPOFFSET+4;
	SCylGadget.TopEdge = PROGRESSBAROFFSET+TopBorder+3;
	ECylGadget.TopEdge = SECONDGROUPOFFSET+TopBorder+5;
	for(i=0; i<15; i++) Gadget[i+8].TopEdge = TopBorder+FOURTHGROUPOFFSET+GADGETSKIP*((i+3)/6);
	Gadget[sizeof(Gadget)/sizeof(struct Gadget)-1].TopEdge = TopBorder+FIRSTGROUPOFFSET;
	NewWindow.Height = WINDOWHEIGHT+TopBorder;
	if (Screen) BorderColorsFlat();
	else {
		BorderColors();
		ZoomPos[2] = TextLength(&(SData->RastPort), Title, strlen(Title))+80;
		ZoomPos[3] = TopBorder+1;
	}

	if (Window = OpenWindow(&NewWindow)) {
		if (PubScreenLock) ScreenToFront(PubScreenLock);
		OldWindowPtr = ((struct Process *)Me)->pr_WindowPtr;
		CopyTaskOldWindowPtr = ((struct Process *)Copier)->pr_WindowPtr;
		((struct Process *)Me)->pr_WindowPtr = ((struct Process *)Copier)->pr_WindowPtr = (APTR)Window;
		UpdateWindow();
		UpdateProgress(TRUE);
	}

	if (PubScreenLock) UnlockPubScreen(NULL, PubScreenLock);
	return((char)(Window != 0));
}

/* The star-trek like bar effect */

void StarTrek(void) {

	register unsigned short i;

	if (!Window) return;
	for(i=0; i<80; i++) {
		DrawProgress(i, 3);
		TimerWait(2000);
	}
	for(i=0; i<80; i++) {
		DrawProgress(i, 0);
		TimerWait(2000);
	}
	UpdateProgress(FALSE);
}

/* These functions handle the name list */

static void MoveListUp(void) {
	if (!(Window->Flags & WFLG_ZOOMED)) {
		SetBPen(Window->RPort, 0);
		ScrollRaster(Window->RPort, 0, 8, 357+68, TopBorder+LISTOFFSET+1, 476+68, TopBorder+LISTOFFSET+LISTHEIGHT);
	}
}

void AddName(unsigned char *Name) {
	ObtainSemaphore(&Semaphore);
	if (Window) {
		MoveListUp();
		DrawText(Name, 357+68, LISTOFFSET+LISTHEIGHT-7);
		CurrentListName = (++CurrentListName)%DISKNAMES;
		strncpy(ListName[CurrentListName], Name, 15);
	}
	ReleaseSemaphore(&Semaphore);
}

void ChangeName(unsigned char *Name) {
	ObtainSemaphore(&Semaphore);
	if (Window) {
		SetDrMd(Window->RPort, JAM2);
		SetAPen(Window->RPort, 0);
		RectFill(Window->RPort, 357+68, TopBorder+LISTOFFSET+LISTHEIGHT-7, 476+68, TopBorder+LISTOFFSET+LISTHEIGHT);
		if (strlen(Name)>15) Name[15] = 0;
		DrawText(Name, 357+68, LISTOFFSET+LISTHEIGHT-7);
		strcpy(ListName[CurrentListName], Name);
	}
	ReleaseSemaphore(&Semaphore);
}

/* Functions to output elapsed time etc. */

void WriteElapsed(struct timeval *a, struct timeval *b) {

	ObtainSemaphore(&Semaphore);
	if (Window && Window->WScreen->LayerInfo.Lock.ss_NestCount == 0) {
		sprintf(s, "%3d.%02d", (unsigned short)(b->tv_secs-a->tv_secs-(b->tv_micro<a->tv_micro))%1000, (unsigned short)((b->tv_micro>=a->tv_micro ? b->tv_micro-a->tv_micro : 1000000UL-a->tv_micro+b->tv_micro)/10000));
		DrawText(s, 425+68, FIRSTGROUPOFFSET+4);
	}
	ReleaseSemaphore(&Semaphore);
}

void WriteRetriesErrors(unsigned char Unit, unsigned short Track) {

	ObtainSemaphore(&Semaphore);
	if (Window) {
		sprintf(s, "%3d:%3d", Retries[Unit]%1000, Errors[Unit]%1000);
		DrawText(s, 80+4+Unit*68, SECONDGROUPOFFSET+GADGETSKIP+4);
		if (Track<160) {
			PrintErrorRectAt(Unit, Track);
			Error[Unit][Track/8] |= 1<<(Track%8);
		}
	}
	ReleaseSemaphore(&Semaphore);
}

void WriteCopies(void) {
	ObtainSemaphore(&Semaphore);
	if (Window) {
		sprintf(s, "Cpy#%3d", Copies%1000);
		DrawText(s, 80+4+4*68, SECONDGROUPOFFSET+GADGETSKIP+4);
	}
	ReleaseSemaphore(&Semaphore);
}

/*
 * This routines selects or delects a gadget.
 */

void SelectGadget(struct Gadget *G, unsigned char Bool) {

	register unsigned short pos;

	if (!G || ((Bool != 0) == ((G->Flags & SELECTED) != 0))) return;

	if (Window) pos = RemoveGadget(Window, G);

	G->Flags ^= SELECTED;

	if (Window) {
		AddGadget(Window, G, pos);
		RefreshGList(G, Window, NULL, 1);
	}
}


/*
 * This routines toggles a gadget.
 */

void ToggleGadget(struct Gadget *G) {
	if (G) SelectGadget(G, !(G->Flags & SELECTED));
}

/*
 * This routine returns the address of a gadget. *MUCH* better than global data.
 * If the gadget is disabled, returns NULL.
 */

struct Gadget *GAddr(short GadgetNumber) {
	return(	GadgetNumber<0 ||
				GadgetNumber>=sizeof(Gadget)/sizeof(struct Gadget) ||
				(Gadget[GadgetNumber].Flags & GADGDISABLED) ||
				!(Gadget[GadgetNumber].Activation & (RELVERIFY | GADGIMMEDIATE | TOGGLESELECT))
				? NULL : &Gadget[GadgetNumber]	);
}


/* Returns the gadget with a certain ID */

short Op2Gadget(unsigned char Op) {
	short i;
	for(i=0; i<sizeof(Gadget)/sizeof(struct Gadget); i++) if (Gadget[i].GadgetID == Op) return(i);
	return(-1);
}


/*
 * EnableGadgets takes a mask of bits and sets
 * all of the gadgets accordingly. Notice that if all it's already OK, we don't
 * do anything.
 */

void EnableGadgets(ULONG Mask, unsigned short SelectThis) {

	register struct Gadget *G = Gadget;
	register unsigned short pos;

	while(G) {
		if ((((Mask & 1) == 0) == ((G->Flags & GADGDISABLED) == 0) && ((G->GadgetType & STRGADGET) || (G->Activation & (RELVERIFY | GADGIMMEDIATE | TOGGLESELECT))))
			|| G->GadgetID == SelectThis) {

			if (Window) pos = RemoveGadget(Window, G);

			if (G->GadgetID == SelectThis) {
				if (Mask & 1) {
					if (SelectThis == 'F') {
						G->Activation |= (GADGIMMEDIATE | TOGGLESELECT);
					}
					else {
						G->Flags &= ~SELECTED;
						G->Activation |= RELVERIFY;
					}
				}
				else {
					G->Flags |= SELECTED;
					G->Activation &= ~(RELVERIFY | GADGIMMEDIATE | TOGGLESELECT);
				}
			}
			else G->Flags ^= GADGDISABLED;

			if (Window) {
				AddGadget(Window, G, pos);
				RefreshGList(G, Window, NULL, 1);
			}
		}

		G = G->NextGadget;
		Mask >>= 1;
	}
}


/* This functions set/get the content of a string/integer gadget. They correctly
	handle the NOGUI case. Also, they are callable from both processes. */

static unsigned char SetGadgetBuffer(struct Gadget *G, unsigned char *p) {

	register unsigned short pos;
	if (G->Flags & GADGDISABLED) return(1);
	ObtainSemaphore(&Semaphore);
	if (Window) pos = RemoveGadget(Window, G);
	strncpy(((struct StringInfo *)(G->SpecialInfo))->Buffer, p, ((struct StringInfo *)(G->SpecialInfo))->MaxChars-1);
	if (Window) {
		AddGadget(Window, G, pos);
		RefreshGList(G, Window, NULL, 1);
	}
	ReleaseSemaphore(&Semaphore);
	return(0);
}

static unsigned char *GetGadgetBuffer(struct Gadget *G) {

	register unsigned short pos;
	ObtainSemaphore(&Semaphore);
	if (Window) {
		pos = RemoveGadget(Window, G);
		AddGadget(Window, G, pos);
	}
	ReleaseSemaphore(&Semaphore);
	return((unsigned char *)((struct StringInfo *)(G->SpecialInfo))->Buffer);
}

static unsigned char SetGadgetNumber(struct Gadget *G, unsigned short n) {

	register unsigned short pos;
	if ((G->Flags & GADGDISABLED) || n>99) return(1);
	ObtainSemaphore(&Semaphore);
	if (Window) pos = RemoveGadget(Window, G);
	sprintf(((struct StringInfo *)(G->SpecialInfo))->Buffer, "%d", n);
	((struct StringInfo *)(G->SpecialInfo))->LongInt = n;
	if (Window) {
		AddGadget(Window, G, pos);
		RefreshGList(G, Window, NULL, 1);
	}
	ReleaseSemaphore(&Semaphore);
	return(0);
}

static unsigned short GetGadgetNumber(struct Gadget *G) {

	register unsigned short pos, n;
	ObtainSemaphore(&Semaphore);
	if (Window) pos = RemoveGadget(Window, G);
	if ((n = ((struct StringInfo *)(G->SpecialInfo))->LongInt)>99) n = 0;
	if (Window) AddGadget(Window, G, pos);
	ReleaseSemaphore(&Semaphore);
	return(n);
}

/* These are the specific calls for specific gadgets */

unsigned char SetDeviceName(unsigned char *p) {
	return(SetGadgetBuffer(&VDNameGadget, p));
}

unsigned char SetDiskName(unsigned char *p) {
	return(SetGadgetBuffer(&StrGadget, p));
}

unsigned char *GetDeviceName(void) {
	return(GetGadgetBuffer(&VDNameGadget));
}

unsigned char *GetDiskName(void) {
	return(GetGadgetBuffer(&StrGadget));
}

unsigned short GetRetryNumber(void) {
	return(GetGadgetNumber(&RetryGadget));
}

unsigned short GetVDNumber(void) {
	return(GetGadgetNumber(&VDNumberGadget));
}

unsigned char SetRetryNumber(unsigned short n) {
	return(SetGadgetNumber(&RetryGadget, n));
}

unsigned char SetVDNumber(unsigned short n) {
	return(SetGadgetNumber(&VDNumberGadget, n));
}

unsigned short GetSCyl(void) {
	return(GetGadgetNumber(&SCylGadget));
}

unsigned short GetECyl(void) {
	return(GetGadgetNumber(&ECylGadget));
}

unsigned char SetSCyl(unsigned short n) {
	return(SetGadgetNumber(&SCylGadget,n));
}

unsigned char SetECyl(unsigned short n) {
	return(SetGadgetNumber(&ECylGadget, n));
}

/* This one deselects all buffer gadgets, except possibly one */

void DeselectBufferGadgets(unsigned char NotThis) {

	register unsigned short i;
	for(i=BUFFER; i<=VDBUF; i++) if (i != NotThis) SelectGadget(&Gadget[i], FALSE);
}

/* Here we deselect all disk gadgets */

void DeselectDiskGadgets(void) {

	register unsigned short i;
	for(i=DF0S; i<=DF3D; i++) SelectGadget(&Gadget[i], FALSE);
}

void ActivateStringGadget(unsigned char Op) {

	struct Gadget *G;

	if (!Window) return;
	switch(Op) {
		case 'L':	G = &StrGadget;
						break;
		case 'Y':	G = &RetryGadget;
						break;
		case 'M':	G = &VDNameGadget;
						break;
		default:		G = NULL;
						break;
	}
	if (G && !(G->Flags & GADGDISABLED)) ActivateGadget(G, Window, NULL);
}

/* Here we increment the disk name */

void IncrementDiskName(void) {

	unsigned short carry = 1;
	unsigned char *p, *q;

	if (!StrInfo.Buffer[0]) return;
	p = StrInfo.Buffer+strlen(StrInfo.Buffer)-1;
	while(p>=StrInfo.Buffer && (*p<'0' || *p>'9')) p--;
	if (p<StrInfo.Buffer) return;
	q = p;
	while(p>=StrInfo.Buffer && *p>='0' && *p<='9') p--;
	while(q>p) {
		if (carry = ((*q += carry) == '9'+1)) *q = '0';
		q--;
	}
}
